

/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <julianacamilo_@hotmail.com> and <thiagums@hotmail.com> wrote this file.
 * As long as you retain this notice you can do whatever you want with this stuff.
 * If we meet some day, and you think this stuff is worth it, you can buy
 * me a beer in return Juliana Camilo Inácio e Thiago Martins de Sousa
 * ----------------------------------------------------------------------------
 */

/*
 * Tradução da Licensa
 *  ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <julianacamilo_@hotmail.com> e <thiagums@hotmail.com>  escreveram esse código.
 * Enquanto você possui-lo, note que  você pode fazer o que desejar com ele. Se um
 * dia a gente se conhecer, e você achar que isso funciona, você pode nos comprar
 * uma cerveja em homenagem a Juliana Camilo Inácio e Thiago Martins de Sousa
 * ----------------------------------------------------------------------------
 */

package pintorj2d;

import java.awt.Color;
import java.awt.Cursor;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Scanner;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 *
 * Essa classe mostra o menu na parte lateral da tela e trata os eventos desses botões
 *
 */

public class JanelaPrincipal extends javax.swing.JFrame {

    public FormaGeometrica f;// variavel f do tipo FormaGeometrica que armazena a forma que que foi selecionada na interface grafica e que sera desenhada
    public Color corLinha;// variavel corLinha do tipo Color para setar a cor selecionda para a forma que sera desenhada

    // operação 1 será desenhada uma forma geométrica
    // operação 2 seleciona uma forma geométrica para preencher cor de fundo
    // operação 3 selecionda o objeto a ser apagado
    public byte operacao;
    public Color corFundo;// variavel corFundo do tipo Color para setar a cor selecionda para o preenchimento da forma que sera selecionada
    public Color aux;// variavel que armazenará a cor original do jPCorPreenchimento.
    ArrayList<FormaGeometrica> formasRecuperadas = new ArrayList<FormaGeometrica>();
    //Lembrar que o jPAreaDeDesenho é um Jpanel do tipo Area

    /**
     * Construtor da janelaPrincipal
     *
     */
    public JanelaPrincipal() {
        initComponents();//inicialiaza os componentes da tela
        f = null;
        operacao = 1;
        corLinha = Color.BLACK;
        corFundo = null;
        //Salva a cor original do botão de preenchimento
        aux = jPCorPreenchimento.getBackground();
        // Fazendo com que a janela da aplicacao fique centralizada ao ser iniciada
        setLocationRelativeTo(null);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        buttonGroup3 = new javax.swing.ButtonGroup();
        jPBarraDeFerramentas = new javax.swing.JPanel();
        jTBRect = new javax.swing.JToggleButton();
        jPanel3 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jTBLinha = new javax.swing.JToggleButton();
        jTBRectArredondado = new javax.swing.JToggleButton();
        jTBElipse = new javax.swing.JToggleButton();
        jTBBorracha = new javax.swing.JToggleButton();
        jTBPreencher = new javax.swing.JToggleButton();
        jPanel2 = new javax.swing.JPanel();
        jPBranco = new javax.swing.JPanel();
        jPAzul = new javax.swing.JPanel();
        jPVerde = new javax.swing.JPanel();
        jPRosa = new javax.swing.JPanel();
        jPAmarelo = new javax.swing.JPanel();
        jPVermelho = new javax.swing.JPanel();
        jPLaranja = new javax.swing.JPanel();
        jPMagenta = new javax.swing.JPanel();
        jPCinza = new javax.swing.JPanel();
        jPPreto = new javax.swing.JPanel();
        jPLinha = new javax.swing.JPanel();
        jPCorLinha = new javax.swing.JPanel();
        jPPreenchimento = new javax.swing.JPanel();
        jPCorPreenchimento = new javax.swing.JPanel();
        jPAreaDeDesenho = new Area(this);
        jMenuBar1 = new javax.swing.JMenuBar();
        jMANovo = new javax.swing.JMenu();
        jMNovo = new javax.swing.JMenuItem();
        jMAbrir = new javax.swing.JMenuItem();
        jMASalvar = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        jMSair = new javax.swing.JMenuItem();
        jMTela = new javax.swing.JMenu();
        jMTLimpar = new javax.swing.JMenuItem();
        jMSobre = new javax.swing.JMenu();
        jMSAutores = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Pintor Vetorial J2D");
        setResizable(false);

        jPBarraDeFerramentas.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        buttonGroup1.add(jTBRect);
        jTBRect.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pintorj2d/rect.png"))); // NOI18N
        jTBRect.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jTBRect.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTBRectMouseClicked(evt);
            }
        });
        jTBRect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTBRectActionPerformed(evt);
            }
        });

        jPanel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel3.setText("Coord:");

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText("0");

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("0");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(32, 32, 32)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, 127, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(4, 4, 4)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2)))
        );

        buttonGroup1.add(jTBLinha);
        jTBLinha.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pintorj2d/linha.png"))); // NOI18N
        jTBLinha.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jTBLinha.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTBLinhaMouseClicked(evt);
            }
        });
        jTBLinha.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTBLinhaActionPerformed(evt);
            }
        });

        buttonGroup1.add(jTBRectArredondado);
        jTBRectArredondado.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pintorj2d/rectArredondado .png"))); // NOI18N
        jTBRectArredondado.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jTBRectArredondado.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTBRectArredondadoMouseClicked(evt);
            }
        });
        jTBRectArredondado.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTBRectArredondadoActionPerformed(evt);
            }
        });

        buttonGroup1.add(jTBElipse);
        jTBElipse.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pintorj2d/elipse.png"))); // NOI18N
        jTBElipse.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jTBElipse.setMaximumSize(new java.awt.Dimension(60, 42));
        jTBElipse.setMinimumSize(new java.awt.Dimension(60, 42));
        jTBElipse.setPreferredSize(new java.awt.Dimension(60, 42));
        jTBElipse.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTBElipseMouseClicked(evt);
            }
        });
        jTBElipse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTBElipseActionPerformed(evt);
            }
        });

        buttonGroup1.add(jTBBorracha);
        jTBBorracha.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pintorj2d/borracha.PNG"))); // NOI18N
        jTBBorracha.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jTBBorracha.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTBBorrachaActionPerformed(evt);
            }
        });

        buttonGroup1.add(jTBPreencher);
        jTBPreencher.setIcon(new javax.swing.ImageIcon(getClass().getResource("/pintorj2d/tinta.PNG"))); // NOI18N
        jTBPreencher.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jTBPreencher.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTBPreencherActionPerformed(evt);
            }
        });

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Tabela de cores", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Comic Sans MS", 1, 11))); // NOI18N

        jPBranco.setBackground(new java.awt.Color(255, 255, 255));
        jPBranco.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPBranco.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPBrancoMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPBrancoLayout = new javax.swing.GroupLayout(jPBranco);
        jPBranco.setLayout(jPBrancoLayout);
        jPBrancoLayout.setHorizontalGroup(
            jPBrancoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 29, Short.MAX_VALUE)
        );
        jPBrancoLayout.setVerticalGroup(
            jPBrancoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 21, Short.MAX_VALUE)
        );

        jPAzul.setBackground(new java.awt.Color(51, 51, 255));
        jPAzul.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPAzul.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPAzulMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPAzulLayout = new javax.swing.GroupLayout(jPAzul);
        jPAzul.setLayout(jPAzulLayout);
        jPAzulLayout.setHorizontalGroup(
            jPAzulLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 29, Short.MAX_VALUE)
        );
        jPAzulLayout.setVerticalGroup(
            jPAzulLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 23, Short.MAX_VALUE)
        );

        jPVerde.setBackground(new java.awt.Color(51, 153, 0));
        jPVerde.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPVerde.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPVerdeMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPVerdeLayout = new javax.swing.GroupLayout(jPVerde);
        jPVerde.setLayout(jPVerdeLayout);
        jPVerdeLayout.setHorizontalGroup(
            jPVerdeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 29, Short.MAX_VALUE)
        );
        jPVerdeLayout.setVerticalGroup(
            jPVerdeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 23, Short.MAX_VALUE)
        );

        jPRosa.setBackground(new java.awt.Color(255, 51, 204));
        jPRosa.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPRosa.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPRosaMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPRosaLayout = new javax.swing.GroupLayout(jPRosa);
        jPRosa.setLayout(jPRosaLayout);
        jPRosaLayout.setHorizontalGroup(
            jPRosaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 29, Short.MAX_VALUE)
        );
        jPRosaLayout.setVerticalGroup(
            jPRosaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 24, Short.MAX_VALUE)
        );

        jPAmarelo.setBackground(new java.awt.Color(255, 255, 51));
        jPAmarelo.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPAmarelo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPAmareloMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPAmareloLayout = new javax.swing.GroupLayout(jPAmarelo);
        jPAmarelo.setLayout(jPAmareloLayout);
        jPAmareloLayout.setHorizontalGroup(
            jPAmareloLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 29, Short.MAX_VALUE)
        );
        jPAmareloLayout.setVerticalGroup(
            jPAmareloLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 24, Short.MAX_VALUE)
        );

        jPVermelho.setBackground(new java.awt.Color(255, 0, 0));
        jPVermelho.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPVermelho.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPVermelhoMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPVermelhoLayout = new javax.swing.GroupLayout(jPVermelho);
        jPVermelho.setLayout(jPVermelhoLayout);
        jPVermelhoLayout.setHorizontalGroup(
            jPVermelhoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 29, Short.MAX_VALUE)
        );
        jPVermelhoLayout.setVerticalGroup(
            jPVermelhoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 24, Short.MAX_VALUE)
        );

        jPLaranja.setBackground(new java.awt.Color(255, 153, 51));
        jPLaranja.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPLaranja.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPLaranjaMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPLaranjaLayout = new javax.swing.GroupLayout(jPLaranja);
        jPLaranja.setLayout(jPLaranjaLayout);
        jPLaranjaLayout.setHorizontalGroup(
            jPLaranjaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 29, Short.MAX_VALUE)
        );
        jPLaranjaLayout.setVerticalGroup(
            jPLaranjaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 24, Short.MAX_VALUE)
        );

        jPMagenta.setBackground(new java.awt.Color(153, 0, 255));
        jPMagenta.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPMagenta.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPMagentaMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPMagentaLayout = new javax.swing.GroupLayout(jPMagenta);
        jPMagenta.setLayout(jPMagentaLayout);
        jPMagentaLayout.setHorizontalGroup(
            jPMagentaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 29, Short.MAX_VALUE)
        );
        jPMagentaLayout.setVerticalGroup(
            jPMagentaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 23, Short.MAX_VALUE)
        );

        jPCinza.setBackground(new java.awt.Color(153, 153, 153));
        jPCinza.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPCinza.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPCinzaMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPCinzaLayout = new javax.swing.GroupLayout(jPCinza);
        jPCinza.setLayout(jPCinzaLayout);
        jPCinzaLayout.setHorizontalGroup(
            jPCinzaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 29, Short.MAX_VALUE)
        );
        jPCinzaLayout.setVerticalGroup(
            jPCinzaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 23, Short.MAX_VALUE)
        );

        jPPreto.setBackground(new java.awt.Color(0, 0, 0));
        jPPreto.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPPreto.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPPretoMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPPretoLayout = new javax.swing.GroupLayout(jPPreto);
        jPPreto.setLayout(jPPretoLayout);
        jPPretoLayout.setHorizontalGroup(
            jPPretoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 29, Short.MAX_VALUE)
        );
        jPPretoLayout.setVerticalGroup(
            jPPretoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 21, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jPPreto, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jPBranco, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jPAzul, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jPVerde, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jPRosa, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jPAmarelo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jPVermelho, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jPLaranja, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jPMagenta, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jPCinza, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPPreto, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPBranco, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(11, 11, 11)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPVerde, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPAzul, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPRosa, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPAmarelo, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPVermelho, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPLaranja, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jPMagenta, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(12, 12, 12))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jPCinza, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addContainerGap())))
        );

        jPLinha.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Cor Linha", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Comic Sans MS", 1, 11))); // NOI18N

        jPCorLinha.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jPCorLinha.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPCorLinhaMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPCorLinhaLayout = new javax.swing.GroupLayout(jPCorLinha);
        jPCorLinha.setLayout(jPCorLinhaLayout);
        jPCorLinhaLayout.setHorizontalGroup(
            jPCorLinhaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 72, Short.MAX_VALUE)
        );
        jPCorLinhaLayout.setVerticalGroup(
            jPCorLinhaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 22, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPLinhaLayout = new javax.swing.GroupLayout(jPLinha);
        jPLinha.setLayout(jPLinhaLayout);
        jPLinhaLayout.setHorizontalGroup(
            jPLinhaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPLinhaLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPCorLinha, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(23, Short.MAX_VALUE))
        );
        jPLinhaLayout.setVerticalGroup(
            jPLinhaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPLinhaLayout.createSequentialGroup()
                .addComponent(jPCorLinha, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPPreenchimento.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Cor Preenchimento", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Comic Sans MS", 1, 11))); // NOI18N

        jPCorPreenchimento.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        javax.swing.GroupLayout jPCorPreenchimentoLayout = new javax.swing.GroupLayout(jPCorPreenchimento);
        jPCorPreenchimento.setLayout(jPCorPreenchimentoLayout);
        jPCorPreenchimentoLayout.setHorizontalGroup(
            jPCorPreenchimentoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 72, Short.MAX_VALUE)
        );
        jPCorPreenchimentoLayout.setVerticalGroup(
            jPCorPreenchimentoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 22, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPPreenchimentoLayout = new javax.swing.GroupLayout(jPPreenchimento);
        jPPreenchimento.setLayout(jPPreenchimentoLayout);
        jPPreenchimentoLayout.setHorizontalGroup(
            jPPreenchimentoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPPreenchimentoLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPCorPreenchimento, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(23, 23, 23))
        );
        jPPreenchimentoLayout.setVerticalGroup(
            jPPreenchimentoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPCorPreenchimento, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        javax.swing.GroupLayout jPBarraDeFerramentasLayout = new javax.swing.GroupLayout(jPBarraDeFerramentas);
        jPBarraDeFerramentas.setLayout(jPBarraDeFerramentasLayout);
        jPBarraDeFerramentasLayout.setHorizontalGroup(
            jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPBarraDeFerramentasLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPBarraDeFerramentasLayout.createSequentialGroup()
                        .addGroup(jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jTBBorracha, javax.swing.GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addComponent(jTBRect, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jTBLinha, javax.swing.GroupLayout.DEFAULT_SIZE, 63, Short.MAX_VALUE)))
                        .addGap(27, 27, 27)
                        .addGroup(jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTBPreencher, javax.swing.GroupLayout.DEFAULT_SIZE, 60, Short.MAX_VALUE)
                            .addComponent(jTBRectArredondado, javax.swing.GroupLayout.DEFAULT_SIZE, 60, Short.MAX_VALUE)
                            .addComponent(jTBElipse, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(295, 295, 295))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPBarraDeFerramentasLayout.createSequentialGroup()
                        .addGap(16, 16, 16)
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(19, 19, 19)))
                .addGap(38, 38, 38))
            .addGroup(jPBarraDeFerramentasLayout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addGroup(jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPLinha, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPPreenchimento, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
            .addGroup(jPBarraDeFerramentasLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(328, 328, 328))
        );
        jPBarraDeFerramentasLayout.setVerticalGroup(
            jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPBarraDeFerramentasLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jTBElipse, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jTBRect, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 47, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jTBLinha, javax.swing.GroupLayout.PREFERRED_SIZE, 45, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTBRectArredondado, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 45, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPBarraDeFerramentasLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jTBPreencher, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jTBBorracha, javax.swing.GroupLayout.DEFAULT_SIZE, 42, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jPLinha, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPPreenchimento, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        jPAreaDeDesenho.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jPAreaDeDesenhoMouseEntered(evt);
            }
        });

        javax.swing.GroupLayout jPAreaDeDesenhoLayout = new javax.swing.GroupLayout(jPAreaDeDesenho);
        jPAreaDeDesenho.setLayout(jPAreaDeDesenhoLayout);
        jPAreaDeDesenhoLayout.setHorizontalGroup(
            jPAreaDeDesenhoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 607, Short.MAX_VALUE)
        );
        jPAreaDeDesenhoLayout.setVerticalGroup(
            jPAreaDeDesenhoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 611, Short.MAX_VALUE)
        );

        jMANovo.setMnemonic('a');
        jMANovo.setText("Arquivo");

        jMNovo.setMnemonic('n');
        jMNovo.setText("Novo");
        jMNovo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMNovoActionPerformed(evt);
            }
        });
        jMANovo.add(jMNovo);

        jMAbrir.setMnemonic('a');
        jMAbrir.setText("Abrir");
        jMAbrir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMAbrirActionPerformed(evt);
            }
        });
        jMANovo.add(jMAbrir);

        jMASalvar.setMnemonic('s');
        jMASalvar.setText("Salvar");
        jMASalvar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMASalvarActionPerformed(evt);
            }
        });
        jMANovo.add(jMASalvar);
        jMANovo.add(jSeparator1);

        jMSair.setMnemonic('r');
        jMSair.setText("Sair");
        jMSair.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMSairActionPerformed(evt);
            }
        });
        jMANovo.add(jMSair);

        jMenuBar1.add(jMANovo);

        jMTela.setMnemonic('t');
        jMTela.setText("Tela");

        jMTLimpar.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_SPACE, java.awt.event.InputEvent.CTRL_MASK));
        jMTLimpar.setMnemonic('l');
        jMTLimpar.setText("Limpar");
        jMTLimpar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMTLimparActionPerformed(evt);
            }
        });
        jMTela.add(jMTLimpar);

        jMenuBar1.add(jMTela);

        jMSobre.setMnemonic('s');
        jMSobre.setText("Sobre");

        jMSAutores.setMnemonic('a');
        jMSAutores.setText("Autores");
        jMSAutores.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMSAutoresActionPerformed(evt);
            }
        });
        jMSobre.add(jMSAutores);

        jMenuBar1.add(jMSobre);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPBarraDeFerramentas, javax.swing.GroupLayout.PREFERRED_SIZE, 187, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPAreaDeDesenho, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPAreaDeDesenho, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPBarraDeFerramentas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
/**
 * Trata evento do botão jTBRect, zera as coordenadas da classe Area
 * Cria um novo Retangulo, altera operação para 1
 *
 * @param evt
 */
    private void jTBRectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTBRectActionPerformed
        // Com este cast é possivel pegar os atributos do tipo area do objeto jPareaDeDesenho (do tipo JPanel) e o executa
        ((Area) this.jPAreaDeDesenho).zerarCoordenadas();
        //Criando objeto do tipo Retangulo e armazenando em f
        this.f = new Retangulo(0, 0, 0, 0, corLinha);
        this.operacao = 1;

    }//GEN-LAST:event_jTBRectActionPerformed

    private void jTBRectMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTBRectMouseClicked
        // TODO add your handling code here:
    }//GEN-LAST:event_jTBRectMouseClicked

    private void jTBElipseMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTBElipseMouseClicked
        // TODO add your handling code here:
    }//GEN-LAST:event_jTBElipseMouseClicked
   /**
    * Trata eventos do botão jTBElipse, zera as coordenadas da classe Area
    * Cria uma nova Elipse, altera a operação para 1
    *
    * @param evt
    */
    private void jTBElipseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTBElipseActionPerformed
      
        ((Area) this.jPAreaDeDesenho).zerarCoordenadas();
        //Criando objeto do tipo Elipse e armazenando em f
        this.f = new Elipse(-1, -1, 0, 0, corLinha);
        this.operacao = 1;
    }//GEN-LAST:event_jTBElipseActionPerformed
/**
 * Trata o evento do Botão jMTLimpar, apaga todas formas desenhadas
 *
 * @param evt
 */
    private void jMTLimparActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMTLimparActionPerformed
        // fazendo coerção ou cast se preferir
        ((Area) this.jPAreaDeDesenho).limparImagem();
    }//GEN-LAST:event_jMTLimparActionPerformed
/**
 * Trata evento do botão jMAbrir, ele carrega as formas salvas no arquivo texto
 *
 * @param evt
 */
    private void jMAbrirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMAbrirActionPerformed
        String formas = null;
        JFileChooser fc = new JFileChooser();
        int retorno = fc.showOpenDialog(this);
        // se um arquivo foi selecionado
        if (retorno == JFileChooser.APPROVE_OPTION) {
            File arquivo = fc.getSelectedFile();
            JOptionPane.showMessageDialog(this, arquivo.getName(), "O arquivo selecionado foi:", JOptionPane.INFORMATION_MESSAGE);
            
            Scanner lendoArquivo = null;
            try {
                // abrindo o arquivo para leitura
                // se o arquivo nao existir será disparada uma exceção
                //Cria Scanner para receber o fluxo de entrada dos bytes
                lendoArquivo = new Scanner(arquivo);
                //Zera o array onde estão salvo as formas geométricas armazenada
                ((Area) this.jPAreaDeDesenho).formasDesenhadas.clear();
                while (lendoArquivo.hasNextLine()) {
                    // le o arquivo linha por linha até chegar ao seu fim e salva
                    // o conteudo da linha na string formas
                    formas = lendoArquivo.nextLine();
                    recuperaArray(formas);
                }
                
            } catch (FileNotFoundException e) { // tratando quando o arquivo nao existe
                System.err.println("Erro: arquivo nao existe. " + arquivo);
            } finally {
                // fechando o scanner
                try {
                    lendoArquivo.close();
                } catch (Exception e) {
                }
            }
        }       
}//GEN-LAST:event_jMAbrirActionPerformed
/**
 * Cria uma forma geometrica a partir da string formas
 *
 * @param formas
 */
    public void recuperaArray(String formas) {

       // salva no array de string dados cada atributo da string formas
        //o separador dos atributos é ":"
        String[] dados = formas.split(":");
        FormaGeometrica auxRec = null;
        int x = Integer.parseInt(dados[0]);
        int y = Integer.parseInt(dados[1]);
        int a = Integer.parseInt(dados[2]);
        int l = Integer.parseInt(dados[3]);
        int tipo = Integer.parseInt(dados[4]);
        int corL = Integer.parseInt(dados[5]);
        Color linha = new Color(corL);
        Color fundo;
        if (dados[6].equals("null")) {
            fundo = null;
        } else {
            int corF = Integer.parseInt(dados[6]);
            fundo = new Color(corF);
        }
        switch (tipo) {
            case 1:

                auxRec = new Retangulo(x, y, a, l, linha, fundo);
                break;
            case 2:
                auxRec = new Linha(x, y, a, l, linha);
                break;
            case 3:
                auxRec = new RetanguloArredondado(x, y, a, l, linha, fundo);
                break;
            case 4:
                auxRec = new Elipse(x, y, a, l, linha, fundo);
                break;
        }
        //adiciona a forma criada ao array de formas desenhadas
        ((Area) this.jPAreaDeDesenho).formasDesenhadas.add(auxRec);
    }
    /**
     * Cria uma janela com a informação dos autores
     *
     * @param evt
     */
    private void jMSAutoresActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMSAutoresActionPerformed

         new util.Sobre(this, rootPaneCheckingEnabled).setVisible(true);
    }//GEN-LAST:event_jMSAutoresActionPerformed
/**
 * Salva as fromas desenhadas em um arquivo texto
 *
 * @param evt
 */
    private void jMASalvarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMASalvarActionPerformed

              JFileChooser fc = new JFileChooser();
        int retorno = fc.showSaveDialog(this);
        // se um arquivo foi selecionado
        if (retorno == JFileChooser.APPROVE_OPTION) {
            File caminho = fc.getSelectedFile();
            JOptionPane.showMessageDialog(this, caminho.getName(), "O arquivo selecionado foi:", JOptionPane.INFORMATION_MESSAGE);
            try {
                FileWriter fwArquivo = null;
                /*
                 * Verifica se o arquivo existe, se existir, ele abre par adicionar dados
                 * se nao existir, ele cria o arquivo
                 */
                if (caminho.exists() == true) {
                    fwArquivo = new FileWriter(caminho, true);
                } else {
                    fwArquivo = new FileWriter(caminho);
                }
                BufferedWriter bw = new BufferedWriter(fwArquivo);

                FormaGeometrica[] formas = ((Area) this.jPAreaDeDesenho).retornaFormas();
                for (int i = 0; i < formas.length; i++) {
                    String tipo = formas[i].getClass().getCanonicalName();
                    if (tipo.equals("pintorj2d.Retangulo")) {
                        tipo = "1";
                    } else if (tipo.equals("pintorj2d.Linha")) {
                        tipo = "2";
                    } else if (tipo.equals("pintorj2d.RetanguloArredondado")) {
                        tipo = "3";
                    } else if (tipo.equals("pintorj2d.Elipse")) {
                        tipo = "4";
                    }
                    String x = Integer.toString(formas[i].x);
                    String y = Integer.toString(formas[i].y);
                    String a = Integer.toString(formas[i].altura);
                    String l = Integer.toString(formas[i].largura);
                    int cl = formas[i].corDaLinha.getRGB();
                    String corL = Integer.toString(cl);
                    String corF = "null";
                    if (formas[i].corDeFundo != null) {
                        int cf = formas[i].corDeFundo.getRGB();
                        corF = Integer.toString(cf);
                    }
                    // Salva os atributos do objeto separados ":" na ordem mostrada abaixo
                    bw.write(x + ":" + y + ":" + a + ":" + l + ":" + tipo + ":" + corL + ":" + corF + "\n");
                }
                                //fecha o arquivo
                bw.close();
                fwArquivo.close();
            } catch (Exception e) {
                System.err.println("Erro ao inserir linhas no arquivo: " + caminho);
            }
        }
}//GEN-LAST:event_jMASalvarActionPerformed

    /**
     * Trata o evento do botao jMSair, e sai do aplicativo
     *
     * @param evt
     */
    private void jMSairActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMSairActionPerformed
        
        System.exit(0);
}//GEN-LAST:event_jMSairActionPerformed

    /**
     * Trata evento do botão jMNovo, limpa as imagens da tela
     *
     * @param evt
     */
    private void jMNovoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMNovoActionPerformed
       
        ((Area) this.jPAreaDeDesenho).limparImagem();
}//GEN-LAST:event_jMNovoActionPerformed
/**
 * Trata o evento do botao jPAreaDeDesenho, e altera o cursor do mouse caso
 * alguma forma ja tenha sido escolhida
 *
 * @param evt
 */
    private void jPAreaDeDesenhoMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPAreaDeDesenhoMouseEntered
       
        if (this.f != null) {
            jPAreaDeDesenho.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
        }
    }//GEN-LAST:event_jPAreaDeDesenhoMouseEntered

    private void jTBLinhaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTBLinhaMouseClicked
        // TODO add your handling code here:
    }//GEN-LAST:event_jTBLinhaMouseClicked

    /**
    * Trata eventos do botão jTBLinha, zera as coordenadas da classe Area
    * Cria uma nova Linha, altera a operação para 1
    *
    * @param evt
    */
    private void jTBLinhaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTBLinhaActionPerformed
        ((Area) this.jPAreaDeDesenho).zerarCoordenadas();
        this.f = new Linha(-1, -1, 0, 0, corLinha);
        this.operacao = 1;

    }//GEN-LAST:event_jTBLinhaActionPerformed

    private void jTBRectArredondadoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTBRectArredondadoMouseClicked
        // TODO add your handling code here:
    }//GEN-LAST:event_jTBRectArredondadoMouseClicked
    /**
    * Trata eventos do botão jTBrectArredondado, zera as coordenadas da classe Area
    * Cria uma novo RetanguloArredondado, altera a operação para 1
    *
    * @param evt
    */
    private void jTBRectArredondadoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTBRectArredondadoActionPerformed
        ((Area) this.jPAreaDeDesenho).zerarCoordenadas();
        this.f = new RetanguloArredondado(-1, -1, 0, 0, corLinha);
        this.operacao = 1;
    }//GEN-LAST:event_jTBRectArredondadoActionPerformed
/**
 * Trata evento do botao jTBBorracha, muda operaçao para 3 (apagar)
 *
 * @param evt
 */
    private void jTBBorrachaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTBBorrachaActionPerformed
        this.operacao = 3;
    }//GEN-LAST:event_jTBBorrachaActionPerformed
/**
 * Trata evento do jPanel jPPreto, seta a Seta a cor da forma geométrica
 * selecionada para a cor do botao pressionado, se operaçao = 1 seta cor de linha
 * se operaçao = 2 seta cor de fundo
 *
 * @param evt
 */
    private void jPPretoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPPretoMouseClicked
        
        if (operacao == 1) {
            corLinha = Color.BLACK;
            jPCorLinha.setBackground(corLinha);
        } else if (operacao == 2) {
            corFundo = Color.BLACK;
            jPCorPreenchimento.setBackground(corFundo);
            //preencher a cor de fundo
        }
    }//GEN-LAST:event_jPPretoMouseClicked
/**
 * Trata evento do jPanel jPBranco, seta a Seta a cor da forma geométrica
 * selecionada para a cor do botao pressionado, se operaçao = 1 seta cor de linha
 * se operaçao = 2 seta cor de fundo
 *
 * @param evt
 */
    private void jPBrancoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPBrancoMouseClicked
        
        if (operacao == 1) {
            corLinha = Color.WHITE;
            jPCorLinha.setBackground(corLinha);
        } else if (operacao == 2) {
            corFundo = Color.WHITE;
            jPCorPreenchimento.setBackground(corFundo);
            //preencher cor de fundo
        }
    }//GEN-LAST:event_jPBrancoMouseClicked
/**
 * Trata evento do jPanel jPAzul, seta a Seta a cor da forma geométrica
 * selecionada para a cor do botao pressionado, se operaçao = 1 seta cor de linha
 * se operaçao = 2 seta cor de fundo
 *
 * @param evt
 */
    private void jPAzulMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPAzulMouseClicked
        
        if (operacao == 1) {
            corLinha = Color.BLUE;
            jPCorLinha.setBackground(corLinha);
        } else if (operacao == 2) {
            corFundo = Color.BLUE;
            jPCorPreenchimento.setBackground(corFundo);
            //preencher cor de fundo
        }
    }//GEN-LAST:event_jPAzulMouseClicked
/**
 * Trata evento do jPanel jPVerde, seta a Seta a cor da forma geométrica
 * selecionada para a cor do botao pressionado, se operaçao = 1 seta cor de linha
 * se operaçao = 2 seta cor de fundo
 *
 * @param evt
 */
    private void jPVerdeMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPVerdeMouseClicked
        
        if (operacao == 1) {
            corLinha = Color.GREEN;
            jPCorLinha.setBackground(corLinha);
        } else if (operacao == 2) {
            corFundo = Color.GREEN;
            jPCorPreenchimento.setBackground(corFundo);
            //preencher cor de fundo
        }
    }//GEN-LAST:event_jPVerdeMouseClicked
/**
 * Trata evento do jPanel jPRosa, seta a Seta a cor da forma geométrica
 * selecionada para a cor do botao pressionado, se operaçao = 1 seta cor de linha
 * se operaçao = 2 seta cor de fundo
 *
 * @param evt
 */
    private void jPRosaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPRosaMouseClicked
        
        if (operacao == 1) {
            corLinha = Color.PINK;
            jPCorLinha.setBackground(corLinha);
        } else if (operacao == 2) {
            corFundo = Color.PINK;
            jPCorPreenchimento.setBackground(corFundo);
            //preencher cor de fundo
        }
    }//GEN-LAST:event_jPRosaMouseClicked
/**
 * Trata evento do jPanel jPAmarelo, seta a Seta a cor da forma geométrica
 * selecionada para a cor do botao pressionado, se operaçao = 1 seta cor de linha
 * se operaçao = 2 seta cor de fundo
 *
 * @param evt
 */
    private void jPAmareloMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPAmareloMouseClicked
        
        if (operacao == 1) {
            corLinha = Color.YELLOW;
            jPCorLinha.setBackground(corLinha);
        } else if (operacao == 2) {
            corFundo = Color.YELLOW;
            jPCorPreenchimento.setBackground(corFundo);
            //ṕreecher com cor de fundo
        }
    }//GEN-LAST:event_jPAmareloMouseClicked
/**
 * Trata evento do jPanel jPVermelho, seta a Seta a cor da forma geométrica
 * selecionada para a cor do botao pressionado, se operaçao = 1 seta cor de linha
 * se operaçao = 2 seta cor de fundo
 *
 * @param evt
 */
    private void jPVermelhoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPVermelhoMouseClicked
        
        if (operacao == 1) {
            corLinha = Color.RED;
            jPCorLinha.setBackground(corLinha);
        } else if (operacao == 2) {
            corFundo = Color.RED;
            jPCorPreenchimento.setBackground(corFundo);
            //preencher com a cor de fundo
        }
    }//GEN-LAST:event_jPVermelhoMouseClicked
/**
 * Trata evento do jPanel jPLaranja, seta a Seta a cor da forma geométrica
 * selecionada para a cor do botao pressionado, se operaçao = 1 seta cor de linha
 * se operaçao = 2 seta cor de fundo
 *
 * @param evt
 */
    private void jPLaranjaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPLaranjaMouseClicked
        
        if (operacao == 1) {
            corLinha = Color.ORANGE;
            jPCorLinha.setBackground(corLinha);
        } else if (operacao == 2) {
            corFundo = Color.ORANGE;
            jPCorPreenchimento.setBackground(corFundo);
            //preencher com cor de fundo
        }
    }//GEN-LAST:event_jPLaranjaMouseClicked
/**
 * Trata evento do jPanel jPMagenta, seta a Seta a cor da forma geométrica
 * selecionada para a cor do botao pressionado, se operaçao = 1 seta cor de linha
 * se operaçao = 2 seta cor de fundo
 *
 * @param evt
 */
    private void jPMagentaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPMagentaMouseClicked
        
        if (operacao == 1) {
            corLinha = Color.MAGENTA;
            jPCorLinha.setBackground(corLinha);
        } else if (operacao == 2) {
            corFundo = Color.MAGENTA;
            jPCorPreenchimento.setBackground(corFundo);
            //preencher cor de fundo
        }
    }//GEN-LAST:event_jPMagentaMouseClicked
/**
 * Trata evento do jPanel jPCinza, seta a Seta a cor da forma geométrica
 * selecionada para a cor do botao pressionado, se operaçao = 1 seta cor de linha
 * se operaçao = 2 seta cor de fundo
 *
 * @param evt
 */
    private void jPCinzaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPCinzaMouseClicked
        
        if (operacao == 1) {
            corLinha = Color.GRAY;
            jPCorLinha.setBackground(corLinha);
        } else if (operacao == 2) {
            corFundo = Color.GRAY;
            jPCorPreenchimento.setBackground(corFundo);
            //preencher com cor de fundo
        }
    }//GEN-LAST:event_jPCinzaMouseClicked
/**
 * Trata o evento do jPanel jPCorLinha, seta o jPanel para a cor selecionada
 *
 * @param evt
 */
    private void jPCorLinhaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPCorLinhaMouseClicked
        jPCorLinha.setBackground(corLinha);

    }//GEN-LAST:event_jPCorLinhaMouseClicked
/**
 * Trata evento do botao jTBPreencher, muda operaçao para 2
 *
 * @param evt
 */
    private void jTBPreencherActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTBPreencherActionPerformed
        this.operacao = 2;
    }//GEN-LAST:event_jTBPreencherActionPerformed



    /**
     * Iniciliza o programa
     *
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new JanelaPrincipal().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.ButtonGroup buttonGroup3;
    public javax.swing.JLabel jLabel1;
    public javax.swing.JLabel jLabel2;
    public javax.swing.JLabel jLabel3;
    private javax.swing.JMenu jMANovo;
    private javax.swing.JMenuItem jMASalvar;
    private javax.swing.JMenuItem jMAbrir;
    private javax.swing.JMenuItem jMNovo;
    private javax.swing.JMenuItem jMSAutores;
    private javax.swing.JMenuItem jMSair;
    private javax.swing.JMenu jMSobre;
    private javax.swing.JMenuItem jMTLimpar;
    private javax.swing.JMenu jMTela;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPanel jPAmarelo;
    private javax.swing.JPanel jPAreaDeDesenho;
    private javax.swing.JPanel jPAzul;
    private javax.swing.JPanel jPBarraDeFerramentas;
    private javax.swing.JPanel jPBranco;
    private javax.swing.JPanel jPCinza;
    private javax.swing.JPanel jPCorLinha;
    private javax.swing.JPanel jPCorPreenchimento;
    private javax.swing.JPanel jPLaranja;
    private javax.swing.JPanel jPLinha;
    private javax.swing.JPanel jPMagenta;
    private javax.swing.JPanel jPPreenchimento;
    private javax.swing.JPanel jPPreto;
    private javax.swing.JPanel jPRosa;
    private javax.swing.JPanel jPVerde;
    private javax.swing.JPanel jPVermelho;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JToggleButton jTBBorracha;
    private javax.swing.JToggleButton jTBElipse;
    private javax.swing.JToggleButton jTBLinha;
    private javax.swing.JToggleButton jTBPreencher;
    private javax.swing.JToggleButton jTBRect;
    private javax.swing.JToggleButton jTBRectArredondado;
    // End of variables declaration//GEN-END:variables
}
